#!/usr/bin/perl -w

use strict;
use IO::Socket;

$| = 1; # autoflush

unless(@ARGV) {
	print "Usage: $0 <mp3 directory>\n";
	exit;
}

my @mp3z;

for(@ARGV) {
	print "open $_\n";
	my @tmp = <$_/*.mp3>; #mp3 directory
	push(@mp3z, @tmp);
}

print "\n\nStart mp3 Log -------------------------------->\n\n";

my $port = 8008; #server port

sub shuffle {
	my $array = shift;
	my $i; 
	for($i = @$array; --$i;) {
		my $j = int rand($i+1);
		next if $i == $j; 
		@$array[$i, $j] = @$array[$j, $i];
	}   
}   

my $server = IO::Socket::INET->new(
				LocalPort => $port,
				Type      => SOCK_STREAM,
				Reuse     => 1,
				Listen    => 10,) || die "can't listen on port $port : $@\n";

$SIG{CHLD} = 'IGNORE'; # if child die..

while ( my $client = $server->accept() ) { #connections
	if ( my $pid = fork() ) { #parent
		next;
	}

    #child
	#print $client "HTTP/1.0 200 OK\n";
	#print $client "Content-Type: audio/x-mp3stream\n";
	#print $client "Cache-Control: no-cache \n";
	#print $client "Pragma: no-cache \n";
	#print $client "Connection: close \n";
	#print $client "x-audiocast-name: Perlmania Cast :-)\n\n";

	print $client "ICY 200 OK\n";
	print $client "icy-notice1:<BR>This stream requires <a href=\"http://www.winamp.com/\">Winamp</a><BR>\n";
	print $client "icy-notice2:Merong~*<BR>\n";
	print $client "icy-name:Sanitizer :D\n";
	print $client "icy-genre:pop & Korean pop\n";
	print $client "icy-url:http://spiritualize.org:8008\n";
	print $client "icy-pub:1\n";
	print $client "icy-br:24\n\n";
	#print $client "icy-metaint:8192\n\n";

	$client->timeout(10);
	#$server->blocking(0);
	shuffle( \@mp3z );

	foreach my $mp3 ( pop(@mp3z) ) {
		my $timestr = scalar localtime();
		print "$timestr / ".$client->peerhost."\tPut-> $mp3\n"; #log
		open MP3, "<$mp3" || die "can't open $mp3";
		binmode(MP3);
		my $temp;
		while(read( MP3,$temp, 8192 )) {
			print $client $temp; #put 1k
			#select(undef, undef, undef, 0.03); #wait a bit.
		#    print ++$c . "\t$byte sended..\n";
		}
		close MP3;
	}
	close( $client );
	exit;
}
